From a53c00380bfa51438632f0cd3cfa8c850f1fe31e Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Fri, 3 Feb 2012 15:05:04 -0600
Subject: Making better use of internal grade API

---
 grade/report/quick_edit/classes/lib.php       |   62 ++++++++++++------------
 grade/report/quick_edit/screens/grade/lib.php |    4 +-
 grade/report/quick_edit/screens/user/lib.php  |    6 +-
 3 files changed, 36 insertions(+), 36 deletions(-)

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index 5c7fa34..be2f623 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -43,15 +43,15 @@ abstract class quick_edit_screen {
         return "$min - $max";
     }
 
-    public function format_override($item, $grade) {
-        if ($item->itemtype == 'manual') {
+    public function format_override($grade) {
+        if (!$grade->grade_item->is_overridable_item()) {
             return get_string('notavailable', 'gradereport_quick_edit');
         }
 
         return $this->checkbox_attribute($grade, 'override', $grade->is_overridden());
     }
 
-    public function format_exclude($item, $grade) {
+    public function format_exclude($grade) {
         return $this->checkbox_attribute($grade, 'exclude', $grade->is_excluded());
     }
 
@@ -70,6 +70,8 @@ abstract class quick_edit_screen {
             $grade = new grade_grade($default, false);
         }
 
+        $grade->grade_item = $item;
+
         return $grade;
     }
 
@@ -94,7 +96,7 @@ abstract class quick_edit_screen {
             $this->make_toggle($key);
     }
 
-    private function checkbox_attribute($grade, $post_name, $is_checked) {
+    protected function checkbox_attribute($grade, $post_name, $is_checked) {
         $name = $post_name . '_' . $grade->itemid . '_' . $grade->userid;
 
         $attributes = array(
@@ -119,48 +121,50 @@ abstract class quick_edit_screen {
         );
     }
 
-    public function format_grade($grade, $decimals) {
-        $name = 'grade_' . $grade->itemid . '_' . $grade->userid;
-
+    public function format_grade($grade) {
         $finalgrade = $grade->finalgrade ?
-            format_float($grade->finalgrade, $decimals) :
+            format_float($grade->finalgrade, $grade->grade_item->get_decimals()) :
             '';
 
-        $attributes = array(
-            'type' => 'text',
-            'name' => $name,
-            'value' => $finalgrade
-        );
-
-        $hidden = array(
-            'type' => 'hidden',
-            'name' => 'old' . $name,
-            'value' => $finalgrade
-        );
+        $is_disabled = ($grade->grade_item->is_overridable_item() and !$grade->is_overridden());
 
-        return (
-            html_writer::empty_tag('input', $attributes) .
-            html_writer::empty_tag('input', $hidden)
-        );
+        return $this->text_attribute($grade, 'grade', $finalgrade, $is_disabled);
     }
 
     public function format_feedback($grade) {
-        $name = 'feedback_' . $grade->itemid . '_' . $grade->userid;
-
         $feedback = $grade->feedback ?
             format_text($grade->feedback, $grade->feedbackformat) :
             '';
 
+        $is_disabled = (
+            $grade->grade_item->is_overridable_item_feedback() and
+            !$grade->is_overridden()
+        );
+
+        return $this->text_attribute($grade, 'feedback', $feedback, $is_disabled);
+    }
+
+    public function heading() {
+        return get_string('pluginname', 'gradereport_quick_edit');
+    }
+
+    protected function text_attribute($grade, $post_name, $value, $is_disabled = false) {
+        $name = $post_name . '_' . $grade->itemid . '_' . $grade->userid;
+
         $attributes = array(
             'type' => 'text',
             'name' => $name,
-            'value' => $feedback
+            'value' => $value
         );
 
+        if ($is_disabled) {
+            $attributes['disabled'] = 'DISABLED';
+        }
+
         $hidden = array(
             'type' => 'hidden',
             'name' => 'old' . $name,
-            'value' => $feedback
+            'value' => $value
         );
 
         return (
@@ -169,10 +173,6 @@ abstract class quick_edit_screen {
         );
     }
 
-    public function heading() {
-        return get_string('pluginname', 'gradereport_quick_edit');
-    }
-
     public abstract function init();
 
     public abstract function html();
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index 14eff7e..eaa1833 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -60,7 +60,7 @@ class quick_edit_grade extends quick_edit_screen {
             $OUTPUT->user_picture($user),
             $this->format_link('user', $user->id, $fullname),
             $this->item_range(),
-            $this->format_grade($grade, $this->item->get_decimals()),
+            $this->format_grade($grade),
             $this->format_feedback($grade)
         );
 
@@ -69,7 +69,7 @@ class quick_edit_grade extends quick_edit_screen {
 
     public function additional_cells($line, $grade) {
         if ($this->requires_extra) {
-            $line[] = $this->format_override($this->item, $grade);
+            $line[] = $this->format_override($grade);
         }
 
         return $line;
diff --git a/grade/report/quick_edit/screens/user/lib.php b/grade/report/quick_edit/screens/user/lib.php
index d5f1520..3895cdc 100644
--- a/grade/report/quick_edit/screens/user/lib.php
+++ b/grade/report/quick_edit/screens/user/lib.php
@@ -57,10 +57,10 @@ class quick_edit_user extends quick_edit_screen {
             $this->format_link('grade', $item->id, $item->itemname),
             $this->category($item)->get_name(),
             $this->format_range($item),
-            $this->format_grade($grade, $item->get_decimals()),
+            $this->format_grade($grade),
             $this->format_feedback($grade),
-            $this->format_override($item, $grade),
-            $this->format_exclude($item, $grade)
+            $this->format_override($grade),
+            $this->format_exclude($grade)
         );
     }
 
-- 
1.7.1


